//+------------------------------------------------------------------+
//| DailyScalp.mq4 |
//|  |
//| 
//+------------------------------------------------------------------+
#property copyright "borrowed some code from mpfx"
#property link "http://www.stideas.com"
extern bool       useTimeFilter           = true;
extern int        HourBegin               = 4;
extern int        HourEnd                 = 18;
extern double TakeProfit = 30;
extern double Lots = 1;
extern double     MaximumRisk       =5;//percentage of account to risk each order
extern double     DecreaseFactor    =3;//lot size reducer during losing streak
 double TrailingStop = 99;
extern double Stoploss = 17;
//extern double Pips = 16;
//extern double Perc = 5;

double Points;
int init ()
{
  Points = MarketInfo (Symbol(), MODE_POINT);
  //----
  return(0);
}
//+------------------------------------------------------------------+
//| |
//+------------------------------------------------------------------+
int deinit()
{
  return(0);
}
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| expert start function |
//+------------------------------------------------------------------+
int start()
{
  double Levv=0;
  int cnt=0, total, res;

  if(Bars<10)
  {
    Print("bars less than 100");
    return(0);
  }  
  if(OrdersTotal()<1 && WorkTime())
  {
    //if(AccountFreeMargin()<(1*Lots))
    //{
    //  Print("BrokeAsAJoke");
    //  return(0);
    //}
    Levv= LotsOptimized(Stoploss);//AccountEquity()*(Perc/100/100)/10;
    

    // (BUY)
    if (Close[1]>Close[2])
    {
      res=OrderSend(NULL,OP_BUY,Levv,Ask,3,Bid-Stoploss*Points,Ask+TakeProfit*Points,0,0,Red);
      return(0);
    }
    if (Close[1]>Close[2])
    {
      res=OrderSend(NULL,OP_BUY,Levv,Ask,3,Bid-Stoploss*Points,Ask+TakeProfit*Points,0,0,Red);
      return(0);
    }
    // (SELL)
    if (Close[1]<Close[2])
    {
      res=OrderSend(NULL,OP_SELL,Levv,Bid,3,Ask+Stoploss*Points,Bid-TakeProfit*Points,0,0,Red);
      return(0);
    }
    if (Close[1]<Close[2])
    {
      res=OrderSend(NULL,OP_SELL,Levv,Bid,3,Ask+Stoploss*Points,Bid-TakeProfit*Points,0,0,Red);
      return(0);
    }
    return(0);
  }

  total=OrdersTotal();
  for(cnt=0;cnt<OrdersTotal();cnt++)
  {
    if(!OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES))continue;
    if(OrderType()<=OP_SELL && OrderSymbol()==Symbol())
    {
      if(OrderType()==OP_BUY)
      {
        if(OrderOpenTime() - CurTime() >= 86400) //1 Day//
        {
          res=OrderClose(OrderTicket(),OrderLots(),Ask,3,Violet);
          return(0);
        }
      }
    }
  }

  total=OrdersTotal();
  for(cnt=0;cnt<OrdersTotal();cnt++)
  {
    if(!OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES))continue;
    if(OrderType()<=OP_BUY && OrderSymbol()==Symbol())
    {
      if(OrderType()==OP_SELL)
      {
        if (OrderOpenTime() - CurTime() >= 86400) //1 Day//
        {
          res=OrderClose(OrderTicket(),OrderLots(),Bid,3,Violet);
          return(0);
        }
      }
    }
  }
  return 0;
}

double LotsOptimized(double _sl)
  {
   double lot=Lots;
   double MinLots=MarketInfo(Symbol(),MODE_MINLOT);
   double MaxLots=MarketInfo(Symbol(),MODE_MAXLOT);
   double TickVal=MarketInfo(Symbol(),MODE_TICKVALUE);
   int    orders=HistoryTotal();     // history orders total
   int    losses=0;                  // number of losses orders without a break
   int digLots=0;
   if(MinLots<0.1)digLots=2;
   else
      if(MinLots<1)digLots=1;
//--- select lot size
   if(_sl<=0)_sl=iATR(Symbol(),PERIOD_D1,8,1)/Point;
   if(MaximumRisk>0) lot=NormalizeDouble(AccountFreeMargin()*MaximumRisk/100/TickVal/_sl,digLots);
//--- calcuulate number of losses orders without a break
   if(DecreaseFactor>0)
     {
      for(int i=orders-1;i>=0;i--)
        {
         if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false)
           {
            Print("Error in history!");
            break;
           }
         if(OrderSymbol()!=Symbol() || OrderType()>OP_SELL)
            continue;
         //---
         if(OrderProfit()>0) break;
         if(OrderProfit()<0) losses++;
        }
      if(losses>1)
         lot=NormalizeDouble(lot-lot*losses/DecreaseFactor,digLots);
     }
//--- return lot size
   return(MathMin(MaxLots,MathMax(MinLots,lot)));
  }
  
  bool WorkTime()
  {
   if(!useTimeFilter) return true;
   int currHour=TimeHour(TimeCurrent());
   if(HourBegin<HourEnd && currHour>=HourBegin && currHour<HourEnd)return true;
   if(HourBegin>=HourEnd && (currHour>=HourBegin || currHour<HourEnd))return true;
   return false;
  }